from __future__ import annotations

import copy
from typing import Tuple, TypeVar

T = TypeVar("T", bound="Entity")

class Entity:
	def __init__(
		self,
		x: int = 0,
		y: int = 0,
		char: str = "?",
		color: Tuple[int, int, int] = (255, 255, 255),
		name: str = "<Unnamed>",
		walkable: bool = True
		):
		self.x = x
		self.y = y
		self.char = char
		self.color = color
		self.name = name
		self.walkable = walkable

	def clone(self: T, x: int, y: int) -> T:
		clone = copy.deepcopy(self)
		clone.x = x
		clone.y = y
		return clone

	def set_pos(self, x: int, y: int) -> None:
		self.x = x
		self.y = y
